/*
 * Created on May 27, 2012
 */

package riven.virtualthreads.test;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.JPanel;

public class GameCanvas extends JPanel {
   
   @Override
   public void addNotify() {
      super.addNotify();
      
      this.addMouseListener(new MouseAdapter() {
         @Override
         public void mousePressed(MouseEvent e) {
            Vec2 p = new Vec2(e.getX(), e.getY());
            
            // add lumberjack
            {
               GameItemLumberjack lumberjack = new GameItemLumberjack();
               lumberjack.position.set(p);
               Game.addItem(lumberjack);
            }
         }
      });
   }
   
   @Override
   protected void paintComponent(Graphics g) {
      super.paintComponent(g);
      
      for (GameItem item : Game.ITEMS0) {
         
         g.setColor(Color.BLUE);
         
         int x_ = (int) item.position.x;
         int y_ = (int) item.position.y;
         
         for (Vec2 pos : item.destinations) {
            int x = (int) pos.x;
            int y = (int) pos.y;
            
            g.drawLine(x_, y_, x, y);
            x_ = x;
            y_ = y;
         }
         
         for (Vec2 pos : item.destinations) {
            int x = (int) pos.x;
            int y = (int) pos.y;
            g.fillRect(x - 2, y - 2, 4, 4);
         }
         
         int x = (int) item.position.x;
         int y = (int) item.position.y;
         g.setColor(item.color);
         g.fillRect(x - 3, y - 3, 6, 6);
         
         g.setColor(Color.BLACK);
         if (item.name != null && !item.name.isEmpty()) {
            g.drawString(item.toString(), x + 10, y);
         }
      }
   }
}
