/*
 * Created on May 27, 2012
 */

package riven.virtualthreads.test;

import java.awt.Color;
import java.util.ArrayList;
import java.util.List;

import de.matthiasmann.continuations.SuspendExecution;

import riven.virtualthreads.VirtualRunnable;
import riven.virtualthreads.VirtualThread;

public class GameItem {
   public String              name           = "";
   public Color               color          = Color.BLACK;
   public Vec2                position       = new Vec2();
   public float               speed          = 1.0f;
   
   public Vec2                shootingTarget = null;
   public List<Vec2>          destinations   = new ArrayList<Vec2>();
   public final ResourceGroup resources      = new ResourceGroup();
   
   @Override
   public String toString() {
      return String.valueOf(this.name) + "" + this.resources.toString();
   }
   
   private List<VirtualThread> spawned;
   
   void spawn(VirtualRunnable task) {
      if (this.spawned == null) {
         this.spawned = new ArrayList<VirtualThread>();
      }
      
      VirtualThread thread = new VirtualThread(task);
      this.spawned.add(thread);
      thread.start();
   }
   
   public void onAdd() {
      //
   }
   
   public void onRemove() {
      //
   }
   
   public void kill() throws SuspendExecution {
      Game.removeItem(this);
      
      if (this.spawned == null) {
         return;
      }
      
      for (VirtualThread thread : this.spawned) {
         thread.kill();
      }
      this.spawned.clear();
   }
   
}
