/*
 * Created on May 27, 2012
 */

package riven.virtualthreads.test;

import java.awt.Color;

import de.matthiasmann.continuations.SuspendExecution;

import riven.virtualthreads.VirtualRunnable;
import riven.virtualthreads.VirtualThread;

public class GameItemStorage extends GameItem {
   
   public GameItemStorage() {
      this.name = "storage";
      this.color = Color.PINK;
      
      this.resources.register(ResourceType.WOOD, new ResourceHolder(9000));
      
      // burn wood
      this.spawn(new VirtualRunnable() {
         @Override
         public void run() throws SuspendExecution {
            while (true) {
               VirtualThread.sleep(1250);
               
               resources.get(ResourceType.WOOD).take(Misc.random(1, 2));
            }
         }
      });
   }
   
   @Override
   public void onAdd() {
      super.onAdd();
      
      Game.STORAGE_GRID.put(this);
   }
   
   @Override
   public void onRemove() {
      super.onRemove();
      
      Game.STORAGE_GRID.remove(this);
   }
}
