/*
 * Created on May 27, 2012
 */

package riven.virtualthreads.test;

import java.awt.Color;

import riven.virtualthreads.VirtualRunnable;
import riven.virtualthreads.VirtualThread;
import de.matthiasmann.continuations.SuspendExecution;

public class GameItemTree extends GameItem {
   
   public GameItemTree() {
      this.name = null;
      this.color = Color.GREEN;
      
      this.resources.register(ResourceType.WOOD, new ResourceHolder(Misc.random(10, 40), 50));
      
      this.spawn(new VirtualRunnable() {
         @Override
         public void run() throws SuspendExecution {
            while (true) {
               VirtualThread.sleep(Misc.random(1100, 2100));
               
               if (Math.random() < 0.01) {
                  if (resources.get(ResourceType.WOOD).getRatio() > 0.50f) {
                     GameItemTree tree = new GameItemTree();
                     tree.position.x = Misc.randomBase(position.x, 32);
                     tree.position.y = Misc.randomBase(position.y, 32);
                     // System.out.println("new tree");
                     Game.addItem(tree);
                  }
               }
               
               if (Math.random() < 0.1) {
                  if (resources.get(ResourceType.WOOD).put(1) == 1) {
                     // System.out.println("grew tree");
                     color = new Color(0, 255 - (resources.get(ResourceType.WOOD).getFilledSpace() * 2), 0);
                  }
               }
               
               if (Math.random() < 0.1) {
                  if (resources.get(ResourceType.WOOD).getRatio() > 0.80f) {
                     // System.out.println("killed tree");
                     kill();
                  }
               }
            }
         }
      });
   }
   
   @Override
   public void onAdd() {
      super.onAdd();
      
      Game.TREE_GRID.put(this);
   }
   
   @Override
   public void onRemove() {
      super.onRemove();
      
      Game.TREE_GRID.remove(this);
   }
}
