/*
 * Created on May 27, 2012
 */

package riven.virtualthreads.test;

import riven.virtualthreads.VirtualRunnable;
import riven.virtualthreads.VirtualThread;
import de.matthiasmann.continuations.SuspendExecution;

public class WaypointOldAI implements VirtualRunnable {
   public final GameItem item;
   
   public WaypointOldAI(GameItem item) {
      this.item = item;
   }
   
   @Override
   public void run() throws SuspendExecution {
      
      while (true) {
         if (this.item.destinations.isEmpty()) {
            // wait for next target
            VirtualThread.sleep(100);
            continue;
         }
         
         // find the next target
         Vec2 src = new Vec2(this.item.position);
         Vec2 dst = this.item.destinations.get(0);
         
         float distance = new Vec2(dst).sub(src).len();
         long duration = (long) ((distance / this.item.speed) * 1000L);
         
         long t0 = Game.TIME;
         long t1 = Game.TIME + duration;
         
         // start moving...
         do {
            VirtualThread.yield(); // wait for next game tick
            
            float ratio = Misc.ratio(Game.TIME, t0, t1);
            Vec2.lerp(Misc.clamp(ratio), src, dst, this.item.position);
         }
         while (Game.TIME <= t1);
         
         // we reached the destination
         this.item.destinations.remove(0);
      }
   }
}
